.586
.MMX
.Model Flat, StdCall
option casemap:none

include \masm32\include\kernel32.inc
include \masm32\include\user32.inc
include \masm32\include\gdi32.inc
include \masm32\include\comctl32.inc
include \masm32\include\comdlg32.inc
include \masm32\include\shell32.inc
;---
includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\user32.lib
includelib \masm32\lib\gdi32.lib
includelib \masm32\lib\comctl32.lib
includelib \masm32\lib\comdlg32.lib
includelib \masm32\lib\shell32.lib
;---
include \masm32\include\windows.inc

; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
.const
align 8
; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
WP_CallBack                 equ [ebp+04]            ; return address
WP_hWnd                     equ [ebp+08]            ; handle window for msg
WP_uMsg                     equ [ebp+12]            ; message number
WP_wParam                   equ [ebp+16]            ; extra message info
WP_lParam                   equ [ebp+20]            ; extra message info
;---
DP_CallBack                 equ [ebp+04]            ; return address
DP_hWnd                     equ [ebp+08]            ; handle window for msg
DP_uMsg                     equ [ebp+12]            ; message number
DP_wParam                   equ [ebp+16]            ; extra message info
DP_lParam                   equ [ebp+20]            ; extra message info

CB_SETCUEBANNER             equ (CBM_FIRST + 3)

; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
.data?
align 8
; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
wc                          WNDCLASSEX <>               ; Structures
msg                         MSG <>
icc                         INITCOMMONCONTROLSEX <>
ps                          PAINTSTRUCT <>
cbei                        COMBOBOXEXITEM <>
;---
ReturnEAX                   dd ?
;---
hInstance                   dd ?
hFntDefGui                  dd ?
hWndCBEx                    dd ?
hWndED                      dd ?

; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
.data
align 8
; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
_MaxTblString               dd 7
_TblString                  dd OFFSET szString1
                            dd OFFSET szString2
                            dd OFFSET szString3
                            dd OFFSET szString4
                            dd OFFSET szString5
                            dd OFFSET szString6
                            dd OFFSET szString7
;---
szCN                        db "4i28567676",0
szWN                        db "ComboBoxEx",0
szMN                        db "ComaMenu",0
CN_ComboBoxEx               db "ComboBoxEx32",0
szCN_Edit                   db "EDIT",0
;---
szString1                   db "Item 1",0
szString2                   db "Item 2",0
szString3                   db "Item 3",0
szString4                   db "Item 4",0
szString5                   db "Item five",0
szString6                   db "Item six",0
szString7                   db "Item seven",0

MyText			    db "Hello World!",0
MyTextBuffer                db 100	dup(0)

; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
.code
align 8
Main:
; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
invoke  GetModuleHandle,0
mov     wc.hInstance,eax
mov     hInstance,eax
;---
mov     icc.dwSize,sizeof INITCOMMONCONTROLSEX
mov     icc.dwICC,ICC_STANDARD_CLASSES or ICC_WIN95_CLASSES
invoke  InitCommonControlsEx,ADDR icc
;---
mov     wc.hIconSm,0
mov     wc.hIcon,0
invoke  LoadCursor,0,IDC_ARROW
mov     wc.hCursor,eax
mov     wc.hbrBackground,COLOR_BTNFACE+1
mov     wc.cbSize,sizeof WNDCLASSEX
mov     wc.style,CS_HREDRAW or CS_VREDRAW
mov     wc.lpfnWndProc,OFFSET WP
mov     wc.cbClsExtra,0
mov     wc.cbWndExtra,0
mov     wc.lpszMenuName,OFFSET szMN
mov     wc.lpszClassName,OFFSET szCN
invoke  RegisterClassEx,ADDR wc
;---
invoke  CreateWindowEx,0,ADDR szCN,ADDR szWN,WS_OVERLAPPED or WS_CAPTION or WS_CLIPCHILDREN or WS_SYSMENU or WS_MINIMIZEBOX,128,128,480,320,0,0,wc.hInstance,0
mov     msg.hwnd,eax
invoke  ShowWindow,msg.hwnd,SW_SHOWNORMAL
invoke  UpdateWindow,msg.hwnd



; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
MessageLoop:
; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
invoke  GetMessage,ADDR msg,0,0,0
cmp     eax,0h
je      TerminateProgram
invoke  TranslateMessage,ADDR msg
invoke  DispatchMessage,ADDR msg
jmp     MessageLoop
; -------------------------------------------------------------------------
TerminateProgram:
invoke  ExitProcess,wc.hInstance
mov     eax,msg.wParam
ret



; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
DP:                                             ; Dialog Procedure
; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
push    ebp
mov     ebp,esp
mov     eax,DP_uMsg
; -------------------------------------------------------------------------
DP_WM_INITDIALOG:
cmp     eax,WM_INITDIALOG
jne     DP_WM_CLOSE
; -------------------------------------------------------------------------
invoke  GetStockObject,DEFAULT_GUI_FONT
mov     hFntDefGui,eax
;---

invoke  CreateWindowEx,0,ADDR szCN_Edit,0,WS_CHILD or WS_VISIBLE or WS_BORDER or WS_CLIPSIBLINGS,8,160,120,40,DP_hWnd,2400,wc.hInstance,0
mov     hWndED,eax

invoke  CreateWindowEx,0,ADDR CN_ComboBoxEx,0,WS_CHILD or WS_VISIBLE or WS_VSCROLL or CBS_DROPDOWN or CBS_AUTOHSCROLL or CBS_NOINTEGRALHEIGHT,15,38,320,240,DP_hWnd,1000,wc.hInstance,0
mov     hWndCBEx,eax
invoke  SendMessage,hWndCBEx,WM_SETFONT,hFntDefGui,1

jmp     Banner

mov     cbei._mask,CBEIF_TEXT
mov     cbei.iItem,-1
mov     ebx,0
mov     esi,OFFSET _TblString
CBExLoop:
mov     eax,[esi]
mov     cbei.pszText,eax
invoke  SendMessage,hWndCBEx,CBEM_INSERTITEM,0,ADDR cbei
add     esi,4
inc     ebx
cmp     ebx,_MaxTblString
jne     CBExLoop

invoke SendMessage,hWndCBEx,CB_SETCURSEL,0,0
;---

Banner:
invoke MultiByteToWideChar,CP_ACP,0,ADDR MyText,-1,ADDR MyTextBuffer,100
invoke SendMessage,hWndCBEx,CB_SETCUEBANNER,0,ADDR MyTextBuffer


jmp     DP_Return1

; -------------------------------------------------------------------------
DP_WM_CLOSE:
cmp     eax,WM_CLOSE
jne     DP_WM_NOTIFY
; -------------------------------------------------------------------------
invoke  DestroyWindow,hWndCBEx
invoke  EndDialog,DP_hWnd,0
jmp     DP_Return1

; -------------------------------------------------------------------------
DP_WM_NOTIFY:
cmp     eax,WM_NOTIFY
jne     DP_WM_COMMAND
; -------------------------------------------------------------------------
mov     ebx,DP_lParam
mov     eax,[ebx+0]
cmp     eax,hWndCBEx
jne     DP_Return0
;---
CBExBeginEdit:
mov     eax,[ebx+8]
cmp     eax,CBEN_BEGINEDIT
jne     CBExEndEdit
;invoke  SetWindowLong,DP_hWnd,DWL_MSGRESULT,0   ; return 0 to allow edit

jmp     DP_Return1
;---
CBExEndEdit:
cmp     eax,CBEN_ENDEDIT                        ; NMCBEENDEDIT structure !
jne     DP_Return0
mov     eax,0
cmp     [ebx+12],eax                            ; fChanged, 0=not changed
jne     CBExEndEditChanged
jmp     DP_Return1                              ; return 1 to abort edit

CBExEndEditChanged:
mov     eax,CBENF_DROPDOWN                      ;CBENF_RETURN - if <Return> needed find out how to use the WM_GETDLGCODE message
cmp     [ebx+20+CBEMAXSTRLEN],eax
je      CBExEndEditReturn
jmp     DP_Return1                              ; return 1 to abort edit

CBExEndEditReturn:
add     ebx,20
mov     cbei.pszText,ebx                        ; pointer to new item text
mov     cbei._mask,CBEIF_TEXT                   ; insert new item
mov     cbei.iItem,-1                           ; at end of list
invoke  SendMessage,hWndCBEx,CBEM_INSERTITEM,0,ADDR cbei
jmp     DP_Return1

; -------------------------------------------------------------------------
DP_WM_COMMAND:
cmp     eax,WM_COMMAND
jne     DP_Return0
mov     eax,DP_wParam                           ; control or menu ID in ax
; -------------------------------------------------------------------------

jmp     DP_Return1

; -------------------------------------------------------------------------
DP_Return:
; -------------------------------------------------------------------------
mov     esp,ebp
pop     ebp
ret     10h
; -------------------------------------------------------------------------
DP_Return0:
; -------------------------------------------------------------------------
mov     eax,0
mov     esp,ebp
pop     ebp
ret     10h
; -------------------------------------------------------------------------
DP_Return1:
; -------------------------------------------------------------------------
mov     eax,1
mov     esp,ebp
pop     ebp
ret     10h



; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
WP:
; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
push    ebp
mov     ebp,esp
pushad
mov     eax,WP_uMsg
; -------------------------------------------------------------------------
WP_WM_CREATE:
cmp     eax,WM_CREATE
jne     WP_WM_DESTROY
; -------------------------------------------------------------------------

jmp     WP_Return

; -------------------------------------------------------------------------
WP_WM_DESTROY:
cmp     eax,WM_DESTROY
jne     WP_WM_PAINT
; -------------------------------------------------------------------------
invoke  PostQuitMessage,0
popad
xor     eax,eax
mov     esp,ebp
pop     ebp
ret     10h

; -------------------------------------------------------------------------
WP_WM_PAINT:
cmp     eax,WM_PAINT
jne     WP_WM_NOTIFY
; -------------------------------------------------------------------------

jmp     WP_Return

; -------------------------------------------------------------------------
WP_WM_NOTIFY:
cmp     eax,WM_NOTIFY
jne     WP_WM_DISPLAYCHANGE
; -------------------------------------------------------------------------

jmp     WP_Return

; -------------------------------------------------------------------------
WP_WM_DISPLAYCHANGE:
cmp     eax,WM_DISPLAYCHANGE
jne     WP_WM_COMMAND
; -------------------------------------------------------------------------
invoke  InvalidateRect,WP_hWnd,0,0
jmp     WP_Return

; -------------------------------------------------------------------------
WP_WM_COMMAND:
cmp     eax,WM_COMMAND
jne     WP_WM_POWERBROADCAST
mov     eax,WP_wParam                           ; control or menu ID in ax
; -------------------------------------------------------------------------
cmp     ax,10000
jne     WP_Return
invoke  DialogBoxParam,wc.hInstance,5000,WP_hWnd,ADDR DP,0
jmp     WP_Return

; -------------------------------------------------------------------------
WP_WM_POWERBROADCAST:
cmp     eax,WM_POWERBROADCAST
jne     WP_Return
; -------------------------------------------------------------------------
mov     eax,WP_wParam
cmp     eax,PBT_APMRESUMESUSPEND
jne     WP_Return
mov     eax,WP_lParam
cmp     eax,PBTF_APMRESUMEFROMFAILURE
je      WP_Return
invoke  RedrawWindow,WP_hWnd,0,0,RDW_ERASE or RDW_INVALIDATE or RDW_UPDATENOW
jmp     WP_Return

; -------------------------------------------------------------------------
WP_Return:
; -------------------------------------------------------------------------
popad
invoke  DefWindowProc,WP_hWnd,WP_uMsg,WP_wParam,WP_lParam
mov     esp,ebp                                 ; delete stack frame
pop     ebp
ret     10h                                     ; return and clear stack
; -------------------------------------------------------------------------
WP_Return0:
; -------------------------------------------------------------------------
popad
mov     eax,0
mov     esp,ebp                                 ; delete stack frame
pop     ebp
ret     10h                                     ; return and clear stack
; -------------------------------------------------------------------------
WP_Return1:
; -------------------------------------------------------------------------
popad
mov     eax,1
mov     esp,ebp                                 ; delete stack frame
pop     ebp
ret     10h                                     ; return and clear stack
; -------------------------------------------------------------------------
WP_ReturnEAX:
; -------------------------------------------------------------------------
popad
mov     eax,ReturnEAX
mov     esp,ebp                                 ; delete stack frame
pop     ebp
ret     10h                                     ; return and clear stack

; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
end Main
; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

